Merge pull request #835 from pi-hole/debugFixes

Debug script tweaks.
pull/842/head
Adam Warner 8 years ago committed by GitHub
commit 5f9e72dd71

@ -1,4 +1,4 @@
usr/bin/env bash
#!/usr/bin/env bash
# Pi-hole: A black hole for Internet advertisements
# (c) 2015, 2016 by Jacob Salmela
# Network-wide ad blocking via your Raspberry Pi
@ -33,32 +33,15 @@ cat << EOM
::: and optionally upload the generated log to a unique and random directory on
::: Termbin.com. NOTE: All log files auto-delete after 1 month and you are the only
::: person who is given the unique URL. Please consider where you post this link.
:::
:::
EOM
######## FIRST CHECK ########
# Must be root to debug
if [[ "${EUID}" -eq 0 ]]; then
echo "::: Script is executing as root user..."
else
echo "::: Non-root user detected..."
# Check if sudo is actually installed
if [ -x "$(command -v sudo)" ]; then
export SUDO="sudo"
echo "::: sudo command located, debug will run under sudo."
else
echo "::: Unable to locate sudo command. Please install sudo or run this as root."
exit 1
fi
fi
# Ensure the file exists, create if not, clear if exists.
if [ ! -f "${DEBUG_LOG}" ]; then
${SUDO} touch ${DEBUG_LOG}
${SUDO} chmod 644 ${DEBUG_LOG}
${SUDO} chown "$USER":root ${DEBUG_LOG}
else
touch ${DEBUG_LOG}
chmod 644 ${DEBUG_LOG}
chown "$USER":root ${DEBUG_LOG}
else
truncate -s 0 ${DEBUG_LOG}
fi
@ -85,31 +68,61 @@ version_check() {
php_ver="$(php -v |& head -n1)" && log_write "${php_ver}" || log_write "PHP not installed."
}
files_check() {
log_write "############################################################"
log_write "########## Files Check ##########"
log_write "############################################################"
#Check existence of setupVars.conf, and source it to get configured network interface for later use in script.
echo -n "::: Detecting existence setupVars.conf..."
setupVars=/etc/pihole/setupVars.conf
if [[ -f ${setupVars} ]];then
echo " found!"
log_write "/etc/pihole/setupVars.conf exists! Contents:"
while read -r line; do
if [ ! -z "${line}" ]; then
[[ "${line}" =~ ^#.*$ ]] && continue
log_write "${line}"
fi
done < "${setupVars}"
log_write ""
. "${setupVars}"
if [[ -n "${piholeInterface}" ]]; then
# prepend % to the beginning of piholeInterface for later use
piholeInterface="%${piholeInterface}"
fi
else
echo " NOT FOUND!"
log_write "/etc/pihole/setupVars.conf not found!"
fi
}
distro_check() {
echo "############################################################" >> ${DEBUG_LOG}
echo "######## Installed OS Distribution #########" >> ${DEBUG_LOG}
echo "############################################################" >> ${DEBUG_LOG}
log_write "############################################################"
log_write "######## Installed OS Distribution #########"
log_write "############################################################"
echo "::: Checking installed OS Distribution release."
TMP=$(cat /etc/*release || echo "Failed to find release")
echo "::: Writing OS Distribution release to logfile."
echo "${TMP}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write "${TMP}"
log_write ""
}
ip_check() {
echo "############################################################" >> ${DEBUG_LOG}
echo "######## IP Address Information #########" >> ${DEBUG_LOG}
echo "############################################################" >> ${DEBUG_LOG}
log_write "############################################################"
log_write "######## IP Address Information #########"
log_write "############################################################"
echo "::: Writing local IPs to logfile"
IPADDR="$(ip a | awk -F " " '{ for(i=1;i<=NF;i++) if ($i == "inet") print $(i+1) }')"
echo "${IPADDR}" >> ${DEBUG_LOG}
log_write "${IPADDR}"
IP6ADDR="$(ip a | awk -F " " '{ for(i=1;i<=NF;i++) if ($i == "inet6") print $(i+1) }')" \
&& echo "${IP6ADDR}" >> ${DEBUG_LOG} || echo "No IPv6 addresses found." >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
&& log_write "${IP6ADDR}" || log_write "No IPv6 addresses found."
log_write ""
echo "::: Locating default gateway and checking connectivity"
GATEWAY=$(ip r | grep default | cut -d ' ' -f 3)
@ -117,88 +130,88 @@ ip_check() {
echo "::: Pinging default IPv4 gateway..."
GATEWAY_CHECK=$(ping -q -w 3 -c 3 -n "${GATEWAY}" | tail -n3)
if [[ $? = 0 ]]; then
echo "IPv4 Gateway check:" >> ${DEBUG_LOG}
log_write "IPv4 Gateway check:"
else
echo "IPv4 Gateway check failed:" >> ${DEBUG_LOG}
log_write "IPv4 Gateway check failed:"
fi
echo "${GATEWAY_CHECK}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write "${GATEWAY_CHECK}"
log_write ""
echo "::: Pinging Internet via IPv4..."
INET_CHECK=$(ping -q -w 5 -c 3 -n 8.8.8.8 | tail -n3)
if [[ $? = 0 ]]; then
echo "IPv4 Internet check:" >> ${DEBUG_LOG}
log_write "IPv4 Internet check:"
else
echo "IPv4 Internet check failed:" >> ${DEBUG_LOG}
log_write "IPv4 Internet check failed:"
fi
echo "${INET_CHECK}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write "${INET_CHECK}"
log_write ""
fi
GATEWAY6=$(ip -6 r | grep default | cut -d ' ' -f 3)
if [[ $? = 0 ]]; then
echo "::: Pinging default IPv6 gateway..."
GATEWAY6_CHECK=$(ping6 -q -w 3 -c 3 -n "${GATEWAY6}" | tail -n3)
GATEWAY6_CHECK=$(ping6 -q -w 3 -c 3 -n "${GATEWAY6}""${piholeInterface}" | tail -n3)
if [[ $? = 0 ]]; then
echo "IPv6 Gateway check:" >> ${DEBUG_LOG}
log_write "IPv6 Gateway check:"
else
echo "IPv6 Gateway check failed:" >> ${DEBUG_LOG}
log_write "IPv6 Gateway check failed:"
fi
echo "::: Pinging Internet via IPv6..."
GATEWAY6_CHECK=$(ping6 -q -w 3 -c 3 -n 2001:4860:4860::8888 | tail -n3)
GATEWAY6_CHECK=$(ping6 -q -w 3 -c 3 -n 2001:4860:4860::8888"${piholeInterface}" | tail -n3)
if [[ $? = 0 ]]; then
echo "IPv6 Internet check:" >> ${DEBUG_LOG}
log_write "IPv6 Internet check:"
else
echo "IPv6 Internet check failed:" >> ${DEBUG_LOG}
log_write "IPv6 Internet check failed:"
fi
else
GATEWAY_CHECK="No IPv6 Gateway Detected"
fi
echo "${GATEWAY_CHECK}" >> ${DEBUG_LOG}
log_write "${GATEWAY_CHECK}"
echo >> ${DEBUG_LOG}
log_write ""
}
hostnameCheck() {
echo "############################################################" >> ${DEBUG_LOG}
echo "######## Hostname Information #########" >> ${DEBUG_LOG}
echo "############################################################" >> ${DEBUG_LOG}
log_write "############################################################"
log_write "######## Hostname Information #########"
log_write "############################################################"
echo "::: Writing locally configured hostnames to logfile"
# Write the hostname output to compare against entries in /etc/hosts, which is logged next
echo "This Pi-hole is: $(hostname)" >> ${DEBUG_LOG}
log_write "This Pi-hole is: $(hostname)"
echo "::: Writing hosts file to debug log..."
echo "### Hosts ###" >> ${DEBUG_LOG}
log_write "### Hosts ###"
if [ -e "${HOSTSFILE}" ]; then
cat "${HOSTSFILE}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write ""
else
echo "No hosts file found!" >> ${DEBUG_LOG}
log_write "No hosts file found!"
printf ":::\tNo hosts file found!\n"
fi
}
portCheck() {
echo "############################################################" >> ${DEBUG_LOG}
echo "######## Open Port Information #########" >> ${DEBUG_LOG}
echo "############################################################" >> ${DEBUG_LOG}
log_write "############################################################"
log_write "######## Open Port Information #########"
log_write "############################################################"
echo "::: Detecting local server port 80 and 53 processes."
${SUDO} lsof -i :80 >> ${DEBUG_LOG}
${SUDO} lsof -i :53 >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
lsof -i :80 >> ${DEBUG_LOG}
lsof -i :53 >> ${DEBUG_LOG}
log_write ""
}
testResolver() {
echo "############################################################" >> ${DEBUG_LOG}
echo "############ Resolver Functions Check ############" >> ${DEBUG_LOG}
echo "############################################################" >> ${DEBUG_LOG}
log_write "############################################################"
log_write "############ Resolver Functions Check ############"
log_write "############################################################"
# Find a blocked url that has not been whitelisted.
@ -218,92 +231,93 @@ testResolver() {
done < "${GRAVITYFILE}"
fi
echo "Resolution of ${TESTURL} from Pi-hole:" >> ${DEBUG_LOG}
log_write "Resolution of ${TESTURL} from Pi-hole:"
LOCALDIG=$(dig "${TESTURL}" @127.0.0.1)
if [[ $? = 0 ]]; then
echo "${LOCALDIG}" >> ${DEBUG_LOG}
log_write "${LOCALDIG}"
else
echo "Failed to resolve ${TESTURL} on Pi-hole" >> ${DEBUG_LOG}
log_write "Failed to resolve ${TESTURL} on Pi-hole"
fi
echo >> ${DEBUG_LOG}
log_write ""
echo "Resolution of ${TESTURL} from 8.8.8.8:" >> ${DEBUG_LOG}
log_write "Resolution of ${TESTURL} from 8.8.8.8:"
REMOTEDIG=$(dig "${TESTURL}" @8.8.8.8)
if [[ $? = 0 ]]; then
echo "${REMOTEDIG}" >> ${DEBUG_LOG}
log_write "${REMOTEDIG}"
else
echo "Failed to resolve ${TESTURL} on 8.8.8.8" >> ${DEBUG_LOG}
log_write "Failed to resolve ${TESTURL} on 8.8.8.8"
fi
echo >> ${DEBUG_LOG}
log_write ""
echo "Pi-hole dnsmasq specific records lookups" >> ${DEBUG_LOG}
echo "Cache Size:" >> ${DEBUG_LOG}
log_write "Pi-hole dnsmasq specific records lookups"
log_write "Cache Size:"
dig +short chaos txt cachesize.bind >> ${DEBUG_LOG}
echo "Insertions count:" >> ${DEBUG_LOG}
log_write "Insertions count:"
dig +short chaos txt insertions.bind >> ${DEBUG_LOG}
echo "Evictions count:" >> ${DEBUG_LOG}
log_write "Evictions count:"
dig +short chaos txt evictions.bind >> ${DEBUG_LOG}
echo "Misses count:" >> ${DEBUG_LOG}
log_write "Misses count:"
dig +short chaos txt misses.bind >> ${DEBUG_LOG}
echo "Hits count:" >> ${DEBUG_LOG}
log_write "Hits count:"
dig +short chaos txt hits.bind >> ${DEBUG_LOG}
echo "Auth count:" >> ${DEBUG_LOG}
log_write "Auth count:"
dig +short chaos txt auth.bind >> ${DEBUG_LOG}
echo "Upstream Servers:" >> ${DEBUG_LOG}
log_write "Upstream Servers:"
dig +short chaos txt servers.bind >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write ""
}
checkProcesses() {
echo "#######################################" >> ${DEBUG_LOG}
echo "########### Processes Check ###########" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
echo ":::"
log_write "#######################################"
log_write "########### Processes Check ###########"
log_write "#######################################"
log_write ":::"
echo "::: Logging status of lighttpd and dnsmasq..."
PROCESSES=( lighttpd dnsmasq )
for i in "${PROCESSES[@]}"; do
echo "" >> ${DEBUG_LOG}
echo -n "${i}" >> "${DEBUG_LOG}"
echo " processes status:" >> ${DEBUG_LOG}
${SUDO} systemctl -l status "${i}" >> "${DEBUG_LOG}"
log_write ""
log_write -n "${i}"
log_write " processes status:"
systemctl -l status "${i}" >> "${DEBUG_LOG}"
done
echo >> ${DEBUG_LOG}
log_write ""
}
debugLighttpd() {
echo "::: Writing lighttpd to debug log..."
echo "#######################################" >> ${DEBUG_LOG}
echo "############ lighttpd.conf ############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "::: Writing lighttpd to debug log..."
log_write "#######################################"
log_write "############ lighttpd.conf ############"
log_write "#######################################"
if [ -e "${LIGHTTPDFILE}" ]; then
while read -r line; do
if [ ! -z "${line}" ]; then
[[ "${line}" =~ ^#.*$ ]] && continue
echo "${line}" >> ${DEBUG_LOG}
log_write "${line}"
fi
done < "${LIGHTTPDFILE}"
echo >> ${DEBUG_LOG}
log_write ""
else
echo "No lighttpd.conf file found!" >> ${DEBUG_LOG}
log_write "No lighttpd.conf file found!"
printf ":::\tNo lighttpd.conf file found\n"
fi
if [ -e "${LIGHTTPDERRFILE}" ]; then
echo "#######################################" >> ${DEBUG_LOG}
echo "######### lighttpd error.log ##########" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "######### lighttpd error.log ##########"
log_write "#######################################"
cat "${LIGHTTPDERRFILE}" >> ${DEBUG_LOG}
else
echo "No lighttpd error.log file found!" >> ${DEBUG_LOG}
log_write "No lighttpd error.log file found!"
printf ":::\tNo lighttpd error.log file found\n"
fi
echo >> ${DEBUG_LOG}
log_write ""
}
### END FUNCTIONS ###
version_check
files_check
distro_check
ip_check
hostnameCheck
@ -313,92 +327,92 @@ testResolver
debugLighttpd
echo "::: Writing dnsmasq.conf to debug log..."
echo "#######################################" >> ${DEBUG_LOG}
echo "############### Dnsmasq ###############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "############### Dnsmasq ###############"
log_write "#######################################"
if [ -e "${DNSMASQFILE}" ]; then
#cat $DNSMASQFILE >> $DEBUG_LOG
while read -r line; do
if [ ! -z "${line}" ]; then
[[ "${line}" =~ ^#.*$ ]] && continue
echo "${line}" >> ${DEBUG_LOG}
log_write "${line}"
fi
done < "${DNSMASQFILE}"
echo >> ${DEBUG_LOG}
log_write ""
else
echo "No dnsmasq.conf file found!" >> ${DEBUG_LOG}
log_write "No dnsmasq.conf file found!"
printf ":::\tNo dnsmasq.conf file found!\n"
fi
echo "::: Writing 01-pihole.conf to debug log..."
echo "#######################################" >> ${DEBUG_LOG}
echo "########### 01-pihole.conf ############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "########### 01-pihole.conf ############"
log_write "#######################################"
if [ -e "${PIHOLECONFFILE}" ]; then
while read -r line; do
if [ ! -z "${line}" ]; then
[[ "${line}" =~ ^#.*$ ]] && continue
echo "${line}" >> ${DEBUG_LOG}
log_write "${line}"
fi
done < "${PIHOLECONFFILE}"
echo >> ${DEBUG_LOG}
log_write
else
echo "No 01-pihole.conf file found!" >> ${DEBUG_LOG}
log_write "No 01-pihole.conf file found!"
printf ":::\tNo 01-pihole.conf file found\n"
fi
echo "::: Writing size of gravity.list to debug log..."
echo "#######################################" >> ${DEBUG_LOG}
echo "############ gravity.list #############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "############ gravity.list #############"
log_write "#######################################"
if [ -e "${GRAVITYFILE}" ]; then
wc -l "${GRAVITYFILE}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write ""
else
echo "No gravity.list file found!" >> ${DEBUG_LOG}
log_write "No gravity.list file found!"
printf ":::\tNo gravity.list file found\n"
fi
### Pi-hole application specific logging ###
echo "::: Writing whitelist to debug log..."
echo "#######################################" >> ${DEBUG_LOG}
echo "############## Whitelist ##############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "############## Whitelist ##############"
log_write "#######################################"
if [ -e "${WHITELISTFILE}" ]; then
cat "${WHITELISTFILE}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write
else
echo "No whitelist.txt file found!" >> ${DEBUG_LOG}
log_write "No whitelist.txt file found!"
printf ":::\tNo whitelist.txt file found!\n"
fi
echo "::: Writing blacklist to debug log..."
echo "#######################################" >> ${DEBUG_LOG}
echo "############## Blacklist ##############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "############## Blacklist ##############"
log_write "#######################################"
if [ -e "${BLACKLISTFILE}" ]; then
cat "${BLACKLISTFILE}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write
else
echo "No blacklist.txt file found!" >> ${DEBUG_LOG}
log_write "No blacklist.txt file found!"
printf ":::\tNo blacklist.txt file found!\n"
fi
echo "::: Writing adlists.list to debug log..."
echo "#######################################" >> ${DEBUG_LOG}
echo "############ adlists.list #############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "############ adlists.list #############"
log_write "#######################################"
if [ -e "${ADLISTSFILE}" ]; then
while read -r line; do
if [ ! -z "${line}" ]; then
[[ "${line}" =~ ^#.*$ ]] && continue
echo "${line}" >> ${DEBUG_LOG}
log_write "${line}"
fi
done < "${ADLISTSFILE}"
echo >> ${DEBUG_LOG}
log_write
else
echo "No adlists.list file found... using adlists.default!" >> ${DEBUG_LOG}
log_write "No adlists.list file found... using adlists.default!"
printf ":::\tNo adlists.list file found... using adlists.default!\n"
fi
@ -407,16 +421,16 @@ fi
dumpPiHoleLog() {
trap '{ echo -e "\n::: Finishing debug write from interrupt... Quitting!" ; exit 1; }' INT
echo -e "::: Writing current Pi-hole traffic to debug log...\n:::\tTry loading any/all sites that you are having trouble with now... \n:::\t(Press ctrl+C to finish)"
echo "#######################################" >> ${DEBUG_LOG}
echo "############# pihole.log ##############" >> ${DEBUG_LOG}
echo "#######################################" >> ${DEBUG_LOG}
log_write "#######################################"
log_write "############# pihole.log ##############"
log_write "#######################################"
if [ -e "${PIHOLELOG}" ]; then
while true; do
tail -f "${PIHOLELOG}" >> ${DEBUG_LOG}
echo >> ${DEBUG_LOG}
log_write ""
done
else
echo "No pihole.log file found!" >> ${DEBUG_LOG}
log_write "No pihole.log file found!"
printf ":::\tNo pihole.log file found!\n"
fi
}

Loading…
Cancel
Save